"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Client = void 0;
var DependencyManager_1 = require("./DependencyManager");
var aws_sdk_1 = require("aws-sdk");
var Resources_1 = require("./Resources");
var Client = /** @class */ (function () {
    function Client(options) {
        this.accountID = null;
        this.options = options;
        this.dependencyManager = new DependencyManager_1.DependencyManager();
        this.sqsClient = new aws_sdk_1.SQS();
        this.snsClient = new aws_sdk_1.SNS();
    }
    Client.prototype.isMockClient = function () {
        return this.options.mockClient;
    };
    Client.prototype.publish = function (publishCommand) {
        return __awaiter(this, void 0, void 0, function () {
            var accountID, topicARN;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: 
                    // Create resources
                    return [4 /*yield*/, this.dependencyManager.satisfySNSPublishDependencies(this, publishCommand)];
                    case 1:
                        // Create resources
                        _a.sent();
                        return [4 /*yield*/, this.getAccountID()];
                    case 2:
                        accountID = _a.sent();
                        topicARN = Resources_1.generateARN('sns', publishCommand.topic.region, accountID, publishCommand.topic.topicName);
                        console.log("Sending SNS Message");
                        return [4 /*yield*/, this.snsClient.publish({
                                Message: publishCommand.message.stringContent,
                                TopicArn: topicARN,
                                MessageAttributes: publishCommand.message.attributes
                            }).promise()];
                    case 3:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Client.prototype.getAccountID = function () {
        return __awaiter(this, void 0, void 0, function () {
            var sts, ret;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.accountID) return [3 /*break*/, 1];
                        return [2 /*return*/, this.accountID];
                    case 1:
                        sts = new aws_sdk_1.STS();
                        return [4 /*yield*/, sts.getCallerIdentity({}).promise()];
                    case 2:
                        ret = _a.sent();
                        if (ret.Account) {
                            this.accountID = ret.Account;
                            return [2 /*return*/, ret.Account];
                        }
                        else {
                            throw new Error('Account Load Failed');
                        }
                        _a.label = 3;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    return Client;
}());
exports.Client = Client;
//# sourceMappingURL=Client.js.map