"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TopicSubscriptionResource = exports.SQSResource = exports.SNSResource = exports.generateARN = void 0;
function generateARN(service, region, accountID, resourceName) {
    return 'arn:aws:' + service + ':' + region + ':' + accountID + ':' + resourceName;
}
exports.generateARN = generateARN;
var Resource = /** @class */ (function () {
    function Resource() {
    }
    Resource.prototype.toString = function () {
        return 'Blank Resource';
    };
    Resource.prototype.ensureAndCreate = function (client) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                throw new Error('Attempted to create blank resource! Use SNSResource, SQSResource or TopicSubscriptionResource');
            });
        });
    };
    return Resource;
}());
var SNSResource = /** @class */ (function (_super) {
    __extends(SNSResource, _super);
    function SNSResource(topicName, region) {
        var _this = _super.call(this) || this;
        _this.topicName = topicName;
        _this.region = region;
        return _this;
    }
    SNSResource.prototype.toString = function () {
        return 'sns.' + this.topicName + '.' + this.region;
    };
    SNSResource.prototype.ensureAndCreate = function (client) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        console.log('Creating SNSResource: ' + this.topicName);
                        return [4 /*yield*/, client.snsClient
                                .createTopic({
                                Name: this.topicName,
                            })
                                .promise()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return SNSResource;
}(Resource));
exports.SNSResource = SNSResource;
var SQSResource = /** @class */ (function (_super) {
    __extends(SQSResource, _super);
    function SQSResource(queueName, region, policyType) {
        var _this = _super.call(this) || this;
        _this.queueName = queueName;
        _this.region = region;
        _this.policyType = policyType;
        return _this;
    }
    SQSResource.prototype.toString = function () {
        return 'sqs.' + this.queueName + '.' + this.region;
    };
    SQSResource.prototype.ensureAndCreate = function (client) {
        return __awaiter(this, void 0, void 0, function () {
            var attributes, accountID, newARN;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        console.log('Creating SQSResource: ' + this.queueName);
                        attributes = {};
                        if (!(this.policyType == 'all-sns')) return [3 /*break*/, 2];
                        return [4 /*yield*/, client.getAccountID()];
                    case 1:
                        accountID = _a.sent();
                        newARN = generateARN('sqs', this.region, accountID, this.queueName);
                        attributes['Policy'] = JSON.stringify({
                            Version: '2012-10-17',
                            Id: 'Policy1645582105705',
                            Statement: [
                                {
                                    Sid: 'Stmt1645582011402',
                                    Effect: 'Allow',
                                    Principal: {
                                        AWS: 'arn:aws:iam::' + accountID + ':root',
                                        Service: 'sns.amazonaws.com',
                                    },
                                    Action: 'SQS:*',
                                    Resource: newARN,
                                },
                            ],
                        });
                        _a.label = 2;
                    case 2: return [4 /*yield*/, client.sqsClient
                            .createQueue({
                            QueueName: this.queueName,
                            Attributes: attributes,
                        })
                            .promise()];
                    case 3:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return SQSResource;
}(Resource));
exports.SQSResource = SQSResource;
var TopicSubscriptionResource = /** @class */ (function (_super) {
    __extends(TopicSubscriptionResource, _super);
    function TopicSubscriptionResource(sns, sqs, filterPolicy) {
        var _this = _super.call(this) || this;
        _this.sns = sns;
        _this.sqs = sqs;
        _this.filterPolicy = filterPolicy;
        return _this;
    }
    TopicSubscriptionResource.prototype.toString = function () {
        return 'subscription[' + this.sqs.toString() + ',' + this.sns.toString() + ',' + JSON.stringify(this.filterPolicy) + ']';
    };
    TopicSubscriptionResource.prototype.ensureAndCreate = function (client) {
        return __awaiter(this, void 0, void 0, function () {
            var attributes, accountID, snsARN, sqsARN;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        console.log('Creating TopicSubscriptionResource: {topic: ' + this.sns.topicName + ', queue: ' + this.sqs.queueName + ', policy: ' + JSON.stringify(this.filterPolicy) + '}');
                        attributes = {};
                        if (this.filterPolicy != null) {
                            attributes['FilterPolicy'] = JSON.stringify(this.filterPolicy);
                        }
                        return [4 /*yield*/, client.getAccountID()];
                    case 1:
                        accountID = _a.sent();
                        snsARN = generateARN('sns', this.sns.region, accountID, this.sns.topicName);
                        sqsARN = generateARN('sqs', this.sqs.region, accountID, this.sqs.queueName);
                        return [4 /*yield*/, client.snsClient
                                .subscribe({
                                TopicArn: snsARN,
                                Protocol: 'sqs',
                                Endpoint: sqsARN,
                                Attributes: attributes,
                            })
                                .promise()];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return TopicSubscriptionResource;
}(Resource));
exports.TopicSubscriptionResource = TopicSubscriptionResource;
//# sourceMappingURL=Resources.js.map